<?php
/*
 * Plugin Name:   WPDevHub Drip Lists
 * Version:       1.4
 * Plugin URI:    http://www.wpdevhub.com/
 * Description:   A powerful plugin to create automated Drip List style content systems.  Systematically release and re-release large sets of content.
 * Author:        WPDevHub
 * Author URI:    http://www.wpdevhub.com/
 */

define('WPDEVHUB_CONST_DDL_PLUGIN_TITLE', 'WPDevHub Drip Lists');
define('WPDEVHUB_CONST_DDL_APP_CODE', 'ddl');

define('WPDEVHUB_CONST_DDL_CLASSES_ZONES', true);
define('WPDEVHUB_CONST_DDL_ZONE_ITEM_NAME', 'List');

// Standard Setup Steps
include dirname(__FILE__).'/inc/inc.setup.php';

// Class Includes
include dirname(__FILE__).'/classes/class.DSCF_DDL_DripLists_Main.php';
include dirname(__FILE__).'/classes/class.DSCF_DDL_DripLists_List.php';
include dirname(__FILE__).'/classes/class.DSCF_DDL_DripLists_Item.php';

// Actions
add_action( 'init', array('DSCF_DDL_DripLists_Main', 'wpActionInit'), 0 );
