/**
 * Created with JetBrains PhpStorm.
 * User: admin
 * Date: 3/24/17
 * Time: 3:36 PM
 * To change this template use File | Settings | File Templates.
 */

// Jquery routine to initialize the Dimbal Object
jQuery(document).ready(function($) {
    DSCF_DDL_Forums_Admin.initialize();
});

var DSCF_DDL_Forums_Admin = {

    initialized:false,
    slug:"WPDEVHUB_CONST_DDL_SLUG",
    url_root:"",
    url_ajax:"",
    url_ajax_load:"",
    elem_base:"DSF_comment_",

    initialize:function() {
        // Setup the URLS
        DSCF_DDL_Forums_Admin.url_root = DSCF_DDL_vars.url;
        DSCF_DDL_Forums_Admin.url_ajax = DSCF_DDL_vars.url_ajax;
        DSCF_DDL_Forums_Admin.url_ajax_load = this.url_root+"/images/loading2.gif";
    },
    getElemId:function(id){
        return this.elem_base+id;
    },

    addComment:function(elemId, threadId){

        var text = jQuery("#"+elemId).val();

        // Get the data from the server
        var queryParams = {
            action: DSCF_DDL_Forums_Admin.slug+"-admin-edit-comment",
            ac: 1,
            comments: text,
            threadId: threadId,
            elemId: elemId
        };

        //Now make the Ajax Request
        jQuery.post(DSCF_DDL_Forums_Admin.url_ajax, queryParams, function( response ){
            if(response == undefined){
                // Bad response
                console.log("Bad Data inside editComment");
            }else{

                commentObject = null;
                if(response.commentObject != undefined){
                    commentObject = response.commentObject;
                }

                var newCommentElemId = DSCF_DDL_Forums_Admin.getElemId(commentObject.id);

                DSCF_DDL_Forums_Admin.displayCommentInThreadEditor(commentObject);

                jQuery("#"+response.elemId).val("");

                DSCF_DDL_Forums_Admin.showBackgroundColor(newCommentElemId, "info");

            }


        });

    },
    editComment:function(commentId){

        var elemId = this.elem_base+commentObject.id;
        var comments = jQuery('#'+elemId+'_comments').val();

        // Get the data from the server
        var queryParams = {
            action: DSCF_DDL_Forums_Admin.slug+"-admin-edit-comment",
            ac: 2,
            commentId: commentId,
            comments: comments
        };

        //Now make the Ajax Request
        jQuery.post(DSCF_DDL_Forums_Admin.url_ajax, queryParams, function( response ){
            if(response == undefined){
                // Bad response
                console.log("Bad Data inside editComment");
            }else{

            }


        });

    },
    changeApproval:function(commentId, approved){

        console.log("Inside changeApproval commentId["+commentId+"] approved["+approved+"]");

        console.log("DSCF_DDL_Forums_Admin object");
        console.dir(DSCF_DDL_Forums_Admin);

        // Get the data from the server
        var queryParams = {
            action: DSCF_DDL_Forums_Admin.slug+"-admin-edit-comment",
            ac: 3,
            commentId: commentId,
            approved: approved
        };

        console.log("URL: "+DSCF_DDL_Forums_Admin.url_ajax);
        console.dir(queryParams);

        //Now make the Ajax Request
        jQuery.post(DSCF_DDL_Forums_Admin.url_ajax, queryParams, function( response ){
            console.log("Response from Ajax Call");
            console.dir(response);
            if(response == undefined){
                // Bad response
                console.log("Bad Data inside changeApproval");
            }else{

                var elemId = DSCF_DDL_Forums_Admin.getElemId(response.commentId);
                var commentId = 0;
                if(response.commentId != undefined){
                    commentId = response.commentId;
                }
                var approved = 0;
                if(response.approved != undefined){
                    approved = response.approved;
                }

                if(approved){
                    jQuery("#"+elemId+"_approval_link").text('remove approval').attr('href', 'javascript:DSCF_DDL_Forums_Admin.changeApproval('+commentId+', 0);');
                    //jQuery("#"+elemId).removeClass("ddl-color-background-warning");
                }else{
                    jQuery("#"+elemId+"_approval_link").text('approve').attr('href', 'javascript:DSCF_DDL_Forums_Admin.changeApproval('+commentId+', 1);');
                    //jQuery("#"+elemId).addClass("ddl-color-background-warning");
                }

                //DSCF_DDL_Forums_Admin.showBackgroundColor(elemId, "info");

            }

        });

    },
    deleteComment:function(commentId){

        // Get the data from the server
        var queryParams = {
            action: DSCF_DDL_Forums_Admin.slug+"-admin-edit-comment",
            ac: 4,
            commentId: commentId
        };

        //Now make the Ajax Request
        jQuery.post(DSCF_DDL_Forums_Admin.url_ajax, queryParams, function( response ){
            if(response == undefined){
                // Bad response
                console.log("Bad Data inside displayPollResponse");
                jQuery("#reportResponse").html("<p>No valid data returned.  Selected poll may not active, valid or have any results yet.</p>");
            }else{
                console.dir(response);
                if(response.code == undefined || response.code != 200){

                }else{
                    console.log("Comment Deleted");

                    var elemId = DSCF_DDL_Forums_Admin.getElemId(response.commentId);
                    jQuery("#"+elemId).remove();

                }

            }


        });

    },
    removeCommentDisplay:function(commentId){
        var elemId = DSCF_DDL_Forums_Admin.getElemId(commentId);
        jQuery("#"+elemId).remove();
    },
    showBackgroundColor:function(elemId, type){
        jQuery("#"+elemId).addClass("ddl-color-background-"+type);
        setTimeout(function(){
            jQuery("#"+elemId).removeClass("ddl-color-background-"+type);
        }, 250);
    }

}
