<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:28 PM
 * To change this template use File | Settings | File Templates.
 */

// Check to see if a Create Post request was made
$publishPost = DSCF_DDL_Utilities::getRequestVarIfExists('publishPost');
$listId = DSCF_DDL_Utilities::getRequestVarIfExists('id');
if(!empty($listId) && !empty($publishPost)){
    // A request was made to create an immediate post from a given advice id
    $list = DSCF_DDL_DripLists_List::get($listId);
    if(!empty($list)){
        // Create the wordpress post and return the new Post ID
        $postId = $list->checkForAutomatedPost(true);
        if(!empty($postId)){
            // If valid - forward the user to it.
            $postEditLink = get_edit_post_link($postId);
            DSCF_DDL_Utilities::addUserMessage('Post successfully Created.  <a href="'.$postEditLink.'">View Post</a>');
        }else{
            DSCF_DDL_Utilities::addUserMessage('No Posts Available.');
        }
    }
    unset($_REQUEST['id']);
}

// Build the Header
echo DSCF_DDL_Utilities::buildHeader(array(
    'title'=>'List Manager',
    'icon'=>WPDEVHUB_CONST_DDL_URL_IMAGES.'/google_custom_search.png',
    'description'=>'Drip Lists allow you to release items in a cycled fashion on a regular basis.  Use this manager to create and maintain these drip list targets.',
    'buttons'=>array(
        0=>array('text'=>'Create New List','params'=>array('page'=>DSCF_DDL_Utilities::buildPageSlug(DSCF_DDL_DripLists_Main::PAGE_LISTS), 'id'=>'new')),
        1=>array('text'=>'View All','params'=>array('page'=>DSCF_DDL_Utilities::buildPageSlug(DSCF_DDL_DripLists_Main::PAGE_LISTS))),
    )
));


DSCF_DDL_Utilities::buildStandardObjectPage('DSCF_DDL_DripLists_List');
